Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# ACE_Thread_Mutex Class Reference

ACE_Thread_Mutex wrapper (only valid for threads in the same process). More...

`#include <Thread_Mutex.h>`

List of all members.

## Public Methods
| ACE_Thread_Mutex (const ACE_TCHAR *name=0, ACE_mutexattr_t *attributes=0)
| Constructor.
| ~ACE_Thread_Mutex (void)
| Implicitly destroy the mutex.
int | remove (void)
int | acquire (void)
| Acquire lock ownership (wait on queue if necessary).
int | acquire (ACE_Time_Value &tv)
int | acquire (ACE_Time_Value *tv)
int | tryacquire (void)
int | release (void)
| Release lock and unblock a thread at head of queue.
int | acquire_read (void)
int | acquire_write (void)
int | tryacquire_read (void)
int | tryacquire_write (void)
int | tryacquire_write_upgrade (void)
const ACE_thread_mutex_t & | lock (void) const
| Return the underlying mutex.
void | dump (void) const
| Dump the state of an object.
## Public Attributes
| ACE_ALLOC_HOOK_DECLARE
| Declare the dynamic allocation hooks.
ACE_thread_mutex_t | lock_
| Mutex type that supports single-process locking efficiently.
int | removed_
## Private Methods
void | operator= (const ACE_Thread_Mutex &)
| ACE_Thread_Mutex (const ACE_Thread_Mutex &)
## Friends
class | ACE_Condition_Thread_Mutex

## Detailed Description

ACE_Thread_Mutex wrapper (only valid for threads in the same process).

This implementation is optimized for locking threads that are in the same process. It maps to <CRITICAL_SECTION>s on NT and <ACE_mutex_t> with <type> set to <USYNC_THREAD> on UNIX. ACE_Thread_Mutex is recursive on some platforms (like Win32). However, on most platforms (like Solaris) it is not recursive. To be totally safe and portable, developers should use <ACE_Recursive_Thread_Mutex> when they need a recursive mutex.

## Constructor & Destructor Documentation

ACE_Thread_Mutex::ACE_Thread_Mutex | ( | const ACE_TCHAR * | name = 0,
|  | ACE_mutexattr_t * | attributes = 0
| ) |

| Constructor.

ACE_Thread_Mutex::~ACE_Thread_Mutex | ( | void |  | ) |

| Implicitly destroy the mutex.

ACE_Thread_Mutex::ACE_Thread_Mutex | ( | const ACE_Thread_Mutex & |  | ) | `[private]`

## Member Function Documentation

ACE_INLINE int ACE_Thread_Mutex::acquire | ( | ACE_Time_Value * | tv | ) |

| If <tv> == 0 the call <acquire()> directly. Otherwise, Block the thread until we acquire the mutex or until <tv> times out, in which case -1 is returned with <errno> == <ETIME>. Note that <*tv> is assumed to be in "absolute" rather than "relative" time. The value of <*tv> is updated upon return to show the actual (absolute) acquisition time.

ACE_INLINE int ACE_Thread_Mutex::acquire | ( | ACE_Time_Value & | tv | ) |

| Block the thread until we acquire the mutex or until <tv> times out, in which case -1 is returned with <errno> == <ETIME>. Note that <tv> is assumed to be in "absolute" rather than "relative" time. The value of <tv> is updated upon return to show the actual (absolute) acquisition time.

ACE_INLINE int ACE_Thread_Mutex::acquire | ( | void |  | ) |

| Acquire lock ownership (wait on queue if necessary).

ACE_INLINE int ACE_Thread_Mutex::acquire_read | ( | void |  | ) |

| Acquire mutex ownership. This calls <acquire> and is only here to make the <ACE_Thread_Mutex> interface consistent with the other synchronization APIs.

ACE_INLINE int ACE_Thread_Mutex::acquire_write | ( | void |  | ) |

| Acquire mutex ownership. This calls <acquire> and is only here to make the <ACE_Thread_Mutex> interface consistent with the other synchronization APIs.

void ACE_Thread_Mutex::dump | ( | void |  | ) | const

| Dump the state of an object.

ACE_INLINE const ACE_thread_mutex_t & ACE_Thread_Mutex::lock | ( | void |  | ) | const

| Return the underlying mutex.

void ACE_Thread_Mutex::operator= | ( | const ACE_Thread_Mutex & |  | ) | `[private]`

ACE_INLINE int ACE_Thread_Mutex::release | ( | void |  | ) |

| Release lock and unblock a thread at head of queue.

ACE_INLINE int ACE_Thread_Mutex::remove | ( | void |  | ) |

| Explicitly destroy the mutex. Note that only one thread should call this method since it doesn't protect against race conditions.

ACE_INLINE int ACE_Thread_Mutex::tryacquire | ( | void |  | ) |

| Conditionally acquire lock (i.e., don't wait on queue). Returns -1 on failure. If we "failed" because someone else already had the lock, <errno> is set to <EBUSY>.

ACE_INLINE int ACE_Thread_Mutex::tryacquire_read | ( | void |  | ) |

| Conditionally acquire mutex (i.e., won't block). This calls <tryacquire> and is only here to make the <ACE_Thread_Mutex> interface consistent with the other synchronization APIs. Returns -1 on failure. If we "failed" because someone else already had the lock, <errno> is set to <EBUSY>.

ACE_INLINE int ACE_Thread_Mutex::tryacquire_write | ( | void |  | ) |

| Conditionally acquire mutex (i.e., won't block). This calls <tryacquire> and is only here to make the <ACE_Thread_Mutex> interface consistent with the other synchronization APIs. Returns -1 on failure. If we "failed" because someone else already had the lock, <errno> is set to <EBUSY>.

ACE_INLINE int ACE_Thread_Mutex::tryacquire_write_upgrade | ( | void |  | ) |

| This is only here to make the <ACE_Thread_Mutex> interface consistent with the other synchronization APIs. Assumes the caller has already acquired the mutex using one of the above calls, and returns 0 (success) always.

## Friends And Related Function Documentation

friend class ACE_Condition_Thread_Mutex`[friend]`

## Member Data Documentation

ACE_Thread_Mutex::ACE_ALLOC_HOOK_DECLARE

| Declare the dynamic allocation hooks.

ACE_thread_mutex_t ACE_Thread_Mutex::lock_

| Mutex type that supports single-process locking efficiently.

int ACE_Thread_Mutex::removed_

| Keeps track of whether <remove> has been called yet to avoid multiple <remove> calls, e.g., explicitly and implicitly in the destructor. This flag isn't protected by a lock, so make sure that you don't have multiple threads simultaneously calling <remove> on the same object, which is a bad idea anyway...

The documentation for this class was generated from the following files:

- /export2/deucetmp/bala/release_try/ACE_wrappers/ace/Thread_Mutex.h
- /export2/deucetmp/bala/release_try/ACE_wrappers/ace/Thread_Mutex.cpp
- /export2/deucetmp/bala/release_try/ACE_wrappers/ace/Thread_Mutex.inl